#include <stdio.h>
#include <pthread.h>

#define NTHREADS 5
#define A 0
#define B 10
#define N 20
#define H (((float)B - (float)A) / N)
float somas[NTHREADS];
void *integral(void *i);
float f(float t);

main() {
  pthread_t thread[NTHREADS];
  float soma;
  int i;

  for (i = 0; i < NTHREADS; i++)
    pthread_create(&thread[i], NULL, integral, (void *)i);

  soma = 0;
  // main thread sincroniza com todos os restantes
  for (i = 0; i < NTHREADS; i++) {
    pthread_join(thread[i], NULL);
    soma += somas[i];
  }

  printf("Area total= %f\n", H * (soma + (f(B) - f(A)) / 2));
}

void *integral(void *region_ptr) {
  float t, soma_parcial;
  int i, region;

  region = (int) region_ptr;
  t = A + region * (B - A) / NTHREADS;  // incio do intervalo
  soma_parcial = 0;
  for (i = 0; i < N / NTHREADS; i++) {
    soma_parcial += f(t);
    t += H;
  }
  somas[region] = soma_parcial;
  return NULL;
}

float f(float t) {
  return t;
}
